#include <cstdlib>
#include <cstdio>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>

using namespace std;

#define sz(x) (int)x.size()
#define FOR(i,a,b) for(int i=a;i<b;++i)
#define PB push_back
#define MAXCHARNUM 20000
#define NEGINF -10000


string infile, outfile;

void print_usage() {
	cout<<"usage: Divibility -i [infile] -o [outfile]"<<endl;
	cout<<"  infile : an inputfile (i.e. div.in)"<<endl;
	cout<<"  outfile: an outputfile (i.e. div.out)"<<endl;
}

void init_env(int argc, char** argv){
	int opt = 0;
	while((opt=getopt(argc, argv, "i:o:h:"))!=EOF) {
		switch(opt) {
		case 'i': {infile  = string(optarg); break;}
		case 'o': {outfile = string(optarg); break;}
		case 'h': {}
		default : {print_usage();exit(0);}
		}
	}
	if(infile.empty() || outfile.empty()){
		print_usage();exit(0);
	}
}


void readin(ifstream & fin, string & seq) {
	char buf[MAXCHARNUM];
	if(fin.good()) {
		fin.getline(buf, MAXCHARNUM);
		seq = string (buf);
	} else seq = "";
}

int max(const int & x, const int & y) {
	return (x<y)?(y):(x);
}

int min(const int & x, const int & y) {
	return (x<y)?(x):(y);
}

int remains(const int & x, const int & y) {
	return (x%y+y)%y;
}

bool DIV(const int & N, const int & K, const vector<int> & a) {
	vector<bool> S1;
	vector<bool> S2;
	FOR(i,0,K) {
		S1.PB(false);
		S2.PB(true);
	}
	S1[0] = true;
	
	FOR(i,1,N+1) {
		FOR(j,0,K) {
			S2[j] = (S1[remains(j-a[i-1], K)] || S1[remains(j+a[i-1], K)]);
		}
		S1 = S2;
	}
	return S2[0];
}

int main(int argc, char** argv) {
	init_env(argc, argv);
	
	ifstream fin(infile.c_str());
	ofstream fout(outfile.c_str());

	int T;
	string seq;
	readin(fin, seq);
	stringstream ss(seq);
	ss>>T;
	cout<<T<<endl;
	FOR(t, 0, T) {
		//case t
		int N, K;
		readin(fin, seq);
		stringstream ss1(seq);
		ss1>>N>>K;
		
		cout<<N<<" "<<K<<endl;
		
		vector<int> vi;
		readin(fin, seq);
		stringstream ss2(seq);

		FOR(i,0,N) {
			int v;
			ss2>>v;
			vi.PB(v);
		}
		bool res = DIV(N, K, vi);
		if(res)
			fout<<"YES"<<endl;
		else 
			fout<<"NO"<<endl;
	}

	fout.close();
	fin.close();
	return 0;
}





