#include <cstdlib>
#include <cstdio>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>

using namespace std;

#define sz(x) (int)x.size()
#define FOR(i,a,b) for(int i=a;i<b;++i)
#define PB push_back
#define MAXCHARNUM 20000
#define NEGINF -10000


string infile, outfile;

void print_usage() {
	cout<<"usage: RollerCoaster -i [infile] -o [outfile]"<<endl;
	cout<<"  infile : an inputfile (i.e. rc.in)"<<endl;
	cout<<"  outfile: an outputfile (i.e. rc.out)"<<endl;
}

void init_env(int argc, char** argv){
	int opt = 0;
	while((opt=getopt(argc, argv, "i:o:h:"))!=EOF) {
		switch(opt) {
		case 'i': {infile  = string(optarg); break;}
		case 'o': {outfile = string(optarg); break;}
		case 'h': {}
		default : {print_usage();exit(0);}
		}
	}
	if(infile.empty() || outfile.empty()){
		print_usage();exit(0);
	}
}


void readin(ifstream & fin, string & seq) {
	char buf[MAXCHARNUM];
	if(fin.good()) {
		fin.getline(buf, MAXCHARNUM);
		seq = string (buf);
	} else seq = "";
}

int max(const int & x, const int & y) {
	return (x<y)?(y):(x);
}

int min(const int & x, const int & y) {
	return (x<y)?(x):(y);
}
int RC(const int & N, const int & K, const int & L, const vector<int> & f, const vector<int> & d) {
	vector<int> S1;
	vector<int> S2;
	
	FOR(j,0,L+1) {
		S1.PB(NEGINF);
		S2.PB(0);
	}
	
	S1[0] = 0;
	FOR(i,1,N+1){
		S2[0] = NEGINF;
		FOR(k,0,min(K,L)+1) {
			S2[0] = max(S2[0], S1[k]);
		}
		FOR(j,1,L+1) {
			int v1 = NEGINF;
			int v2 = NEGINF; 
			if(j+K>L)
				v1 = NEGINF;
			else 
				v1 = S1[j+K];
			
			if(j-d[i-1] >= 0)
				v2 = S1[j-d[i-1]]+f[i-1];
			
			S2[j] = max(v1, v2);
		}
		S1 = S2;
	}
	
	int ret = NEGINF;	
	FOR(j,0,L+1) 
		ret = max(ret, S2[j]);
	return ret;
}

int main(int argc, char** argv) {
	init_env(argc, argv);
	
	ifstream fin(infile.c_str());
	ofstream fout(outfile.c_str());
	
	while(!fin.eof() && fin.good()){
		string seq;
		readin(fin, seq);
		int N, K, L;
		stringstream ss(seq);
		ss>>N>>K>>L;
		if(N==0) break;
		vector<int> f;
		vector<int> d;
		
		FOR(i,0,N) {
			string s;
			readin(fin, s);
			stringstream ss2(s);
			int i1, i2;
			ss2>>i1>>i2;
			f.PB(i1); 
			d.PB(i2);
		}
		
		cout<<"N="<<N<<", K="<<K<<", L="<<L<<endl;
		FOR(i,0,N) {
			cout<<f[i]<<"\t"<<d[i]<<endl;
		}
		int score = RC(N, K, L, f, d);
		fout<<score<<endl;
	}

	fout.close();
	fin.close();
	return 0;
}


